/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_pcb.h 808 2011-05-20 13:50:58Z ertl-honda $
 */

/*
 *  ץå¸ץåȥ֥å⥸塼Nios2ѡ
 */
#ifndef TOPPERS_PRC_PCB_H
#define TOPPERS_PRC_PCB_H

#include "nios2.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  
 */
typedef struct processor_control_block PCB;

/*
 *  Nios2¸ץåȥ֥å
 */
typedef struct target_processor_control_block{
	/*
	 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
	 */
	uint32_t except_nest_count;

	/*
	 * Ƴߤγ׵ػߥե饰ξ
	 */
	uint32_t idf;

	/*
	 *  ߤγͥ٥ޥ͡ɽ
	 */
	uint8_t iipm;

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	uint32_t	bitpat_cfgint;

	/*
	 *  󥿥ƥѤΥåν
	 */
	STK_T* istkpt;

	/*
	 *  ߥޥơ֥ؤΥݥ
	 */
	const uint32_t* p_iipm_mask_tbl;

	/*
	 *  ߥϥɥơ֥ؤΥݥ
	 */
	const FP* p_inh_tbl;

	/*
	 *  ͥ٥ơ֥ؤΥݥ
	 */
	const uint8_t* p_inh_iipm_tbl;

	/*
	 *  CPU㳰ϥɥơ֥ؤΥݥ
	 */
	const FP* p_exch_tbl;

	/*
	 *  ץåֳHWΥ١ɥ쥹
	 */
	uint32_t prc_int_base;
}TPCB;

/*
 *  åη
 */
typedef uint32_t  LOCK;

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_PCB_H */
