/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 722 2010-10-14 04:43:29Z ertl-honda $
 */

/*
 *  ޥɥ饤
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include "nios2_system.h"

/*
 *  ޳ߥϥɥϿΤ
 */
/*
 *  륿Ѥ
 */
#define INHNO_TIMER1     (0x10000 | SYS_CLK_TIMER_1_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER1     (0x10000 | SYS_CLK_TIMER_1_INT)  /* ֹ */
#define INTPRI_TIMER1    (-6)            /* ͥ */
#define INTATR_TIMER1    0U              /* ° */

#define INHNO_TIMER2     (0x20000 | SYS_CLK_TIMER_2_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER2     (0x20000 | SYS_CLK_TIMER_2_INT)  /* ֹ */
#define INTPRI_TIMER2    (-6)            /* ͥ */
#define INTATR_TIMER2    0U              /* ° */

#define INHNO_TIMER3     (0x30000 | SYS_CLK_TIMER_3_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER3     (0x30000 | SYS_CLK_TIMER_3_INT)  /* ֹ */
#define INTPRI_TIMER3    (-6)            /* ͥ */
#define INTATR_TIMER3    0U              /* ° */

#define INHNO_TIMER4     (0x40000 | SYS_CLK_TIMER_4_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER4     (0x40000 | SYS_CLK_TIMER_4_INT)  /* ֹ */
#define INTPRI_TIMER4    (-6)            /* ͥ */
#define INTATR_TIMER4    0U              /* ° */

/*
 *  Х륿Ѥ
 */
#if TOPPERS_SYSTIM_PRCID == 1
#define INHNO_TIMER_SYSTIM    (0x10000|SYS_CLK_TIMER_1_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x10000|SYS_CLK_TIMER_1_INT)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 2
#define INHNO_TIMER_SYSTIM    (0x20000|SYS_CLK_TIMER_2_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x20000|SYS_CLK_TIMER_2_INT)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 3
#define INHNO_TIMER_SYSTIM    (0x30000|SYS_CLK_TIMER_3_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x30000|SYS_CLK_TIMER_3_INT)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 4
#define INHNO_TIMER_SYSTIM    (0x40000|SYS_CLK_TIMER_4_INT)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x40000|SYS_CLK_TIMER_4_INT)  /* ֹ */
#endif /* TOPPERS_SYSTIM_PRCID == 1 */

#define INTPRI_TIMER_SYSTIM   -6    /* ͥ */
#define INTATR_TIMER_SYSTIM    0U   /* ° */

/*
 * ץå¸
 */ 
#include "nios2_gcc/avalon_timer.h"

#endif /* TOPPERS_TARGET_TIMER_H */
